<template>
  <div v-if="isEmpty" class="ob-spot-list__icon">
    <ObTooltip
      :content="tooltipText"
      :disabled="isCancelled"
      position="top-start"
    >
      <i
        :class="[
          'icon',
          { '-cobalt': !isProcessed && !isCancelled },
          auctionIconClass,
          chosenStyle,
          winNoChosenStyle,
          loseNoChosenStyle,
          noBidsStyle,
          cancelledBidsStyle,
        ]"
        :data-qa="dataQaProperty"
      />
    </ObTooltip>
  </div>
  <span v-else>–</span>
</template>

<script>
import { AUCTION_TYPES } from '@/resources/enum'
import ObTooltip from 'common-components/src/obComponents/obTooltip'

export default {
  name: 'auctionType',
  components: {
    ObTooltip,
  },
  props: {
    item: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    return {
      auctionTypes: AUCTION_TYPES,
    }
  },
  computed: {
    isEmpty() {
      return !!this.item.spotOrder.orderStatus
    },
    auctionIconClass() {
      return this.isCancelled
        ? 'close-xs'
        : this.auctionTypes[this.item.type].icon
    },
    isProcessed() {
      return this.item.spotOrder.orderStatus === 'PROCESSED'
    },
    isCancelled() {
      return this.item.spotOrder.orderStatus === 'CANCELLED'
    },
    isNoBids() {
      return this.item.auctionCurrentInfo.currentState === 'NO_BIDS'
    },
    isChosenByCarrier() {
      return this.item.spotOrder.isCarrierChosen
    },
    isDowngrade() {
      return this.item.type === 'DOWNGRADE'
    },
    chosenStyle() {
      return this.isProcessed && this.isChosenByCarrier ? '-green-craiola' : ''
    },
    winNoChosenStyle() {
      return this.isProcessed &&
        !this.isChosenByCarrier &&
        this.item.auctionCurrentInfo.currentState === 'WIN'
        ? '-light-raspberry-red'
        : ''
    },
    loseNoChosenStyle() {
      return this.isProcessed &&
        !this.isChosenByCarrier &&
        this.item.auctionCurrentInfo.currentState === 'LOSING'
        ? '-light-raspberry-red'
        : ''
    },
    noBidsStyle() {
      return this.isNoBids ? '-gray-slate' : ''
    },
    cancelledBidsStyle() {
      return this.isCancelled && !this.isNoBids ? '-light-raspberry-red' : ''
    },
    tooltipText() {
      return this.item.type ? this.auctionTypes[this.item.type].titleShort : '-'
    },
    dataQaProperty() {
      return `'spot-auctionType__icon--${this.auctionTypes[this.item.type].value.toLowerCase()}'`
    }
  },
}
</script>

<style lang="scss" scoped>
.icon:hover {
  cursor: pointer;
}
</style>
